// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_can_msgs:msg/CanFrame.idl
// generated code does not contain a copyright notice
#include "marti_can_msgs/msg/can_frame__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"

bool
marti_can_msgs__msg__CanFrame__init(marti_can_msgs__msg__CanFrame * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_can_msgs__msg__CanFrame__fini(msg);
    return false;
  }
  // id
  // msg_type
  // data_length
  // data
  return true;
}

void
marti_can_msgs__msg__CanFrame__fini(marti_can_msgs__msg__CanFrame * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  // msg_type
  // data_length
  // data
}

marti_can_msgs__msg__CanFrame *
marti_can_msgs__msg__CanFrame__create()
{
  marti_can_msgs__msg__CanFrame * msg = (marti_can_msgs__msg__CanFrame *)malloc(sizeof(marti_can_msgs__msg__CanFrame));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_can_msgs__msg__CanFrame));
  bool success = marti_can_msgs__msg__CanFrame__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_can_msgs__msg__CanFrame__destroy(marti_can_msgs__msg__CanFrame * msg)
{
  if (msg) {
    marti_can_msgs__msg__CanFrame__fini(msg);
  }
  free(msg);
}


bool
marti_can_msgs__msg__CanFrame__Sequence__init(marti_can_msgs__msg__CanFrame__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_can_msgs__msg__CanFrame * data = NULL;
  if (size) {
    data = (marti_can_msgs__msg__CanFrame *)calloc(size, sizeof(marti_can_msgs__msg__CanFrame));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_can_msgs__msg__CanFrame__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_can_msgs__msg__CanFrame__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_can_msgs__msg__CanFrame__Sequence__fini(marti_can_msgs__msg__CanFrame__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_can_msgs__msg__CanFrame__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_can_msgs__msg__CanFrame__Sequence *
marti_can_msgs__msg__CanFrame__Sequence__create(size_t size)
{
  marti_can_msgs__msg__CanFrame__Sequence * array = (marti_can_msgs__msg__CanFrame__Sequence *)malloc(sizeof(marti_can_msgs__msg__CanFrame__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_can_msgs__msg__CanFrame__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_can_msgs__msg__CanFrame__Sequence__destroy(marti_can_msgs__msg__CanFrame__Sequence * array)
{
  if (array) {
    marti_can_msgs__msg__CanFrame__Sequence__fini(array);
  }
  free(array);
}
